//  FileDialog.h version 1.5
//  yudit package - Unicode Editor for the X Window System (and Linux) 
//
//  Author: gsinai@iname.com (Gaspar Sinai)
//  GNU Copyright (C) 1997,1998,1999  Gaspar Sinai
// 
//  yudit version 1.5  Copyright(C) 30 November, 1999, Tokyo Japan  Gaspar Sinai
//  yudit version 1.4  Copyright(C) 25 November, 1999, Tokyo Japan  Gaspar Sinai
//  yudit version 1.3  Copyright(C)  5 April,    1999, Tokyo Japan  Gaspar Sinai
//  yudit version 1.2  Copyright(C) 10 December, 1998, Tokyo Japan  Gaspar Sinai
//  yudit version 1.1  Copyright(C) 23 August,   1998, Tokyo Japan  Gaspar Sinai
//  yudit version 1.0  Copyright(C) 17 May,      1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.99 Copyright(C)  4 April,    1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.97 Copyright(C)  4 February, 1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.95 Copyright(C) 10 January,  1998, Tokyo Japan  Gaspar Sinai
//  yudit version 0.94 Copyright(C) 17 December, 1997, Tokyo Japan  Gaspar Sinai
//  yudit version 0.9 Copyright (C)  8 December, 1997, Tokyo Japan  Gaspar Sinai
//  yutex version 0.8 Copyright (C)  5 November, 1997, Tokyo Japan  Gaspar Sinai
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#ifndef __file_dialog_h__
#define __file_dialog_h__

#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#include <AString.h>

//
// The motif FileSelectionDialog is too buggy to be used :-/
//
class FileDialog
{
public:
	enum FileDialogButton	{OK, CANCEL};

				FileDialog (Widget parent, const char* titleIn);
				~FileDialog();
	const char* 		getString ();
	FileDialogButton	getButton ();
private:
	int			hidden;
	Widget			toplevel;
	Widget			dialog;
	Widget			topForm;
	Widget			dirListLabel;
	Widget			dirList;
	Widget			dirListSW;
	Widget			fileListLabel;
	Widget			fileList;
	Widget			fileListSW;
	Widget			textField;
	Widget			textFieldLabel;

	Widget 			hiddenTB;
	// This is the optionmenu
	Widget			menuLabel;
	Widget			menu;
	Widget			manager;
	Widget			shell;
	Widget*			menuItems;
	int			menuSize;
	int			menuArraySize;

	AString			workingDir;
	AString			fullPathName;

	char*			lastString;
	FileDialogButton	lastButton;
	void			rebuildList();
	void			buildOptionMenu ();
	void			dirPathCheck();
	void			addOptionMenuItem (const char* item);

	friend void	MYuditFileButtonCallback (Widget w, FileDialog* dialog, 
				XmAnyCallbackStruct *cbs);

	friend void	MYuditFileSelectCallback (Widget w, FileDialog* dialog, 
				XmListCallbackStruct *cbs);

	friend void 	MYuditFilePressedCallback (Widget w, FileDialog* dialog,
				XmAnyCallbackStruct *cbs);

};

#endif /* __file_dialog_h__ */
